<template>
  <div>
    <!-- <pre>{{ config }}</pre> -->
    <input type="number" v-model="iidImageRawData">
    <inline-editor v-model="titleImageRawData" :read-only="config.read_only" :class="{ 'read-only': config.read_only }" :style="{ backgroundColor: isFieldEdited({ node, path: [...path, 'title'] }) ? '#c3dfff' : '' }"></inline-editor>
    <inline-editor v-model="altImageRawData" :read-only="config.read_only" :class="{ 'read-only': config.read_only }" :style="{ backgroundColor: isFieldEdited({ node, path: [...path, 'alt'] }) ? '#c3dfff' : '' }"></inline-editor>
    <!-- <div v-if="iid"> -->
    <img v-if="thumbnail" :src="thumbnail"/>
    <div v-if="status === 'loading'">Loading...</div>
    <!-- </div> -->
    <input :id="path.join('.')" name="file" type="file" accept="image/*" @change="imageChange">
    <button v-if="iid" @click="removeImage">Remove image</button>
    <!-- <button>{{ iid ? 'Replace' : 'Add' }} image</button> -->

    <!-- {{ editablePath }} -->
    <!-- <input v-model="fieldData" :disabled="config.read_only" :style="{ backgroundColor: isFieldEdited({ node, path }) ? '#c3dfff' : '' }"> -->
<!--     <inline-editor v-model="textareaRawData" :read-only="config.read_only" :placeholder="textareaPlaceholder" :class="{ 'read-only': config.read_only }" type="multi" :style="{ backgroundColor: isFieldEdited({ node, path }) ? '#c3dfff' : '' }"></inline-editor>
 -->
  </div>
</template>

<script>
import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

import InlineEditor from '@/components/Editable/Utils/InlineEditor'

export default {
  components: {
    InlineEditor
  },

  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    },
    // config: {
    //   type: Object,
    //   required: true
    // },
    defaults: {
      required: false
    }
  },

  data () {
    return {
      formData: new FormData(),
      rawKey: 'inner-html',
      imageId: null
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      isFieldEdited: 'Y3TI/isFieldEdited',
      getFieldConfig: 'Y3TI/getFieldConfig',
      getFileUploadStatus: 'Y3TI/getFileUploadStatus'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    status () {
      return this.imageId ? this.getFileUploadStatus(this.imageId) : null
    },
    // textLinkPlaceholder () {
    //   return _.get(this.config, 'widget.form.settings.placeholder_title')
    // },

    // urlLinkPlaceholder () {
    //   return _.get(this.config, 'widget.form.settings.placeholder_url')
    // },
    iid () {
      return this.getEditedField({ node: this.node, path: [...this.path, 'iid'] })
    },

    thumbnail () {
      return this.getEditedField({ node: this.node, path: [...this.path, 'thumbnail'] }) || this.getEditedField({ node: this.node, path: [...this.path, 'url'] })
    },

    iidImageRawData: {
      get () {
        const data = this.getEditedField({ node: this.node, path: [...this.path, 'iid'] })
        return data === null ? _.get(this.defaults, ['iid']) : data
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: [...this.path, 'iid'], input: value } })
      }
    },

    titleImageRawData: {
      get () {
        const data = this.getEditedField({ node: this.node, path: [...this.path, 'title'], raw: this.rawKey })
        return data === null ? _.get(this.defaults, ['title']) : data
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: [...this.path, 'title'], input: value, raw: this.rawKey } })
      }
    },

    altImageRawData: {
      get () {
        const data = this.getEditedField({ node: this.node, path: [...this.path, 'alt'], raw: this.rawKey })
        return data === null ? _.get(this.defaults, ['alt']) : data
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: [...this.path, 'alt'], input: value, raw: this.rawKey } })
      }
    }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData',
      uploadEditableImage: 'Y3TI/uploadEditableImage'
    }),

    imageChange (event) {
      let fileList = event.target.files
      if (!fileList.length) return

      this.formData.append('files[]', fileList[0], fileList[0].name)
      // Array.from(Array(fileList.length).keys()).map(x => {
      //   this.formData.append('file', fileList[x], fileList[x].name)
      // })
      this.imageId = 'image-' + Date.now()
      this.uploadEditableImage({ data: { file: this.formData, id: this.imageId } }).then(({ data }) => {
        const currentValues = this.getEditedField({ node: this.node, path: this.path })
        const newValues = _.omitBy(_.get(data, ['images', 0], {}), _.isNil)
        this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: _.assign({}, currentValues, newValues) } })
      }).catch((err) => {
        console.log(err)
      }).then(() => {
        this.formData = new FormData()
        event.target.value = ''
        this.imageId = null
      })
    },

    removeImage () {
      this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: null } })
    }
  }
}
</script>

<style lang="scss" scoped>
  .read-only {
    border: gray solid;
    background-color: gray;
    color: white;
  }
</style>
